# https://www.geeksforgeeks.org/how-to-install-sql-server-express-in-linux/
# https://learn.microsoft.com/en-us/answers/questions/1685683/how-to-install-sql-server-2022-on-ubuntu-server-24

curl -O http://debian.mirror.ac.za/debian/pool/main/o/openldap/libldap-2.5-0_2.5.13+dfsg-5_amd64.deb 
sudo dpkg -i libldap-2.5-0_2.5.13+dfsg-5_amd64.deb
curl -O http://debian.mirror.ac.za/debian/pool/main/o/openldap/libldap-dev_2.5.13+dfsg-5_amd64.deb
sudo dpkg -i libldap-dev_2.5.13+dfsg-5_amd64.deb
#First upgrade ubuntu to fix libc packaging issues.
#Then
sudo apt upgrade libsasl2-2
sudo apt --fix-broken install
sudo apt upgrade libldap-2.5-0
sudo apt --fix-broken install

sudo apt update
sudo apt install -y libldap-2.5-0
sudo apt install libldap-common



#curl -OL http://archive.ubuntu.com/ubuntu/pool/main/o/openldap/libldap-2.5-0_2.5.18+dfsg-0ubuntu0.22.04.1_amd64.deb
#sudo apt-get install ./libldap-2.5-0_2.5.18+dfsg-0ubuntu0.22.04.1_amd64.deb

wget -qO- https://packages.microsoft.com/keys/microsoft.asc | sudo apt-key add -

curl -fsSL https://packages.microsoft.com/config/ubuntu/22.04/mssql-server-2022.list | sudo tee /etc/apt/sources.list.d/mssql-server-2022.list
# sudo add-apt-repository “$(wget -qO- https://packages.microsoft.com/config/ubuntu/22.04/mssql-server-2022.list)”
   # sudo add-apt-repository “$(wget -qO- https://packages.microsoft.com/config/ubuntu/20.04/mssql-server-2019.list)”


sudo apt update && sudo apt install -y mssql-server
sudo /opt/mssql/bin/mssql-conf setup

#sudo systemctl status mssql-server.service
sudo systemctl status mssql-server --no-pager
sudo ldd /opt/mssql/bin/sqlservr

curl https://packages.microsoft.com/config/ubuntu/20.04/prod.list | sudo tee /etc/apt/sources.list.d/msprod.list
sudo apt update && sudo apt install -y mssql-tools unixodbc-dev
sudo ln -s /opt/mssql-tools/bin/sqlcmd /usr/local/bin
sqlcmd -S localhost -U SA

setfacl -R -m u:mssql:rwx ~/elvt/pgsys/elixir-data/dbs/elixir/run

SELECT OBJECT_SCHEMA_NAME(object_id) AS SchemaName, name AS TableName
FROM master.sys.objects WHERE type_desc = 'USER_TABLE' AND is_ms_shipped = 0;


# Install redis
# https://docs.vultr.com/how-to-install-redis-on-ubuntu-24-04
sudo apt install redis-server
sudo systemctl enable redis-server.service
sudo systemctl start redis


# sqlcmd -S localhost -U sa -Q "RESTORE DATABASE [ELIXIR_DEV] FROM DISK = N'/home/elvt/elvt/pgsys/elixir-data/dbdumps/reduced_elixir_backup' WITH FILE = 1, NOUNLOAD, REPLACE, NORECOVERY, STATS = 5"

cp /home/elvt/pgsys/elixir-data/dbdumps/reduced_elixir_backup' /tmp
sqlcmd -S localhost -U sa -Q "RESTORE DATABASE ELIXIR FROM DISK = '/tmp/reduced_elixir_backup' WITH MOVE 'Elixir' TO '/var/opt/mssql/data/elixir.mdf', MOVE 'Elixir_log' TO '/var/opt/mssql/data/elixir_log.ldf'"
